## simka 1.5.1

=== CMakeLists.txt ===
project(simka)

cmake_minimum_required(VERSION 2.6)

################################################################################
# The version number.
################################################################################
SET (gatb-tool_VERSION_MAJOR 1)
SET (gatb-tool_VERSION_MINOR 5)
SET (gatb-tool_VERSION_PATCH 1)

IF (DEFINED MAJOR)
    SET (gatb-tool_VERSION_MAJOR ${MAJOR})
ENDIF()
IF (DEFINED MINOR)
    SET (gatb-tool_VERSION_MINOR ${MINOR})
ENDIF()
IF (DEFINED PATCH)
    SET (gatb-tool_VERSION_PATCH ${PATCH})
ENDIF()

set (gatb-tool-version ${gatb-tool_VERSION_MAJOR}.${gatb-tool_VERSION_MINOR}.${gatb-tool_VERSION_PATCH})

# However, continuous integration has priority over local compilation
IF (DEFINED JENKINS_TAG)
    SET (gatb-tool-version ${JENKINS_TAG})
ENDIF()

################################################################################
# Define cmake modules directory
################################################################################
SET (GATB_CORE_HOME  ${PROJECT_SOURCE_DIR}/thirdparty/gatb-core/gatb-core)
SET (CMAKE_MODULE_PATH ${GATB_CORE_HOME}/cmake)

################################################################################
# THIRD PARTIES
################################################################################

# We don't want to install some GATB-CORE artifacts
 SET (GATB_CORE_EXCLUDE_TOOLS     1)
 SET (GATB_CORE_EXCLUDE_TESTS     1)
 SET (GATB_CORE_EXCLUDE_EXAMPLES  1)

# GATB CORE
include (GatbCore)

################################################################################
# TOOL
################################################################################

# we get compilation definitions from the gatb-core part
add_definitions (${gatb-core-flags})

# we add a new compilation variable
if (PRINTALL)
SET( CMAKE_CXX_FLAGS  "${CMAKE_CXX_FLAGS} -DPRINTALL" )
endif()

# we give the headers directories from :
#       - from project source
#       - from GATB-CORE source
#       - from simka source
include_directories (include ${gatb-core-includes} ${PROJECT_SOURCE_DIR}/src/core ${PROJECT_SOURCE_DIR}/src/minikc ${PROJECT_SOURCE_DIR}/src)

# we generate one file per template specialization
FOREACH (KSIZE ${gatb-core-klist})
    configure_file (
        ${PROJECT_SOURCE_DIR}/src/core/SimkaAlgorithmTemplate.cpp.in
        ${PROJECT_BINARY_DIR}/src/core/template/SimkaAlgorithmTemplate_${KSIZE}.cpp
    )
ENDFOREACH ()

# we define the files to be compiled
file (GLOB_RECURSE  ProjectFiles  src/core/Simka*  ${PROJECT_BINARY_DIR}/src/core/template/*.cpp)
file (GLOB_RECURSE  SimkaMinFiles  src/simkaMin/MurmurHash3.h src/simkaMin/MurmurHash3.cpp src/simkaMin/*.hpp)#   ${PROJECT_BINARY_DIR}/src/core/template/*.cpp)

SET(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/bin)
set(PROJECT_BINARY_DIR ${CMAKE_CURRENT_BINARY_DIR}/bin)

add_executable        (simka  src/SimkaPotara.cpp ${ProjectFiles})
target_link_libraries (simka  ${gatb-core-libraries})

add_executable        (simkaCountProcess  src/minikc/SimkaCountProcess.cpp ${ProjectFiles})
target_link_libraries (simkaCountProcess  ${gatb-core-libraries})
add_executable        (simkaCount  src/SimkaCount.cpp ${ProjectFiles})
target_link_libraries (simkaCount  ${gatb-core-libraries})

add_executable        (simkaMerge  src/SimkaMerge.cpp ${ProjectFiles})
target_link_libraries (simkaMerge  ${gatb-core-libraries})

add_executable        (simkaMinCore  src/simkaMin/SimkaMin.cpp ${SimkaMinFiles})
target_link_libraries (simkaMinCore  ${gatb-core-libraries})

################################################################################
#  PACKAGING
################################################################################

SET (CPACK_PACKAGE_DESCRIPTION_SUMMARY  "gatb-tool ${PROJECT_NAME}")
SET (CPACK_PACKAGE_VENDOR               "Genscale team (INRIA)")
SET (CPACK_PACKAGE_VERSION_MAJOR        "${gatb-tool_VERSION_MAJOR}")
SET (CPACK_PACKAGE_VERSION_MINOR        "${gatb-tool_VERSION_MINOR}")
SET (CPACK_PACKAGE_VERSION_PATCH        "${gatb-tool_VERSION_PATCH}")
SET (CPACK_PACKAGE_VERSION              "${gatb-tool-version}")

# We chose the kind of archive we want to generate
SET (CPACK_GENERATOR            "TGZ")
SET (CPACK_SOURCE_GENERATOR     "TGZ")

# We ignore unwanted files for the source archive
SET (CPACK_SOURCE_IGNORE_FILES
    "^${PROJECT_SOURCE_DIR}/\\.git/"     ;
    "^${PROJECT_SOURCE_DIR}/\\.gitmodules" ;
    "^${PROJECT_SOURCE_DIR}/\\.gitignore" ;
    "^${PROJECT_SOURCE_DIR}/build/"  ;
    "^${PROJECT_SOURCE_DIR}/dependency/"  ;
    "^${GATB_CORE_HOME}/\\.cproject" ;
    "^${GATB_CORE_HOME}/\\.git/"     ;
    "^${GATB_CORE_HOME}/\\.project"  ;
    "^${GATB_CORE_HOME}/\\.gitignore"
)

# For creating the BINARY package we include the files we want
INSTALL (DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/bin       DESTINATION .)
INSTALL (DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/example   DESTINATION .)
INSTALL (DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/simkaMin   DESTINATION .)
INSTALL (DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/scripts   DESTINATION . FILES_MATCHING REGEX ".*\\.(py|r)$"  PATTERN "jenkins" EXCLUDE)
INSTALL (FILES     ${CMAKE_CURRENT_SOURCE_DIR}/README.md DESTINATION .)
INSTALL (FILES     ${CMAKE_CURRENT_SOURCE_DIR}/LICENSE   DESTINATION .)

# We include the "bin" tag into binary archive file name
set (CPACK_PACKAGE_FILE_NAME  ${PROJECT_NAME}-${CPACK_PACKAGE_VERSION}-bin-${CMAKE_SYSTEM_NAME})

# To be done at the end.
INCLUDE (CPack)

=== debian/changelog ===
simka (1.5.1-4build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:25:38 +0100

simka (1.5.1-4) unstable; urgency=medium

  * Team upload.
  * Enable arch any and arch all build separately
  * Set upstream metadata fields: Bug-Submit.

 -- Andreas Tille <tille@debian.org>  Sun, 12 Jan 2020 19:17:16 +0100

simka (1.5.1-3) unstable; urgency=medium

  * Team upload.
  * Do not explicitly Depends: libgatbcore2 (trust ${shlibs:Depends} instead)
  * Set upstream metadata fields: Bug-Database, Repository-Browse.

 -- Andreas Tille <tille@debian.org>  Fri, 13 Dec 2019 08:36:28 +0100

simka (1.5.1-2) unstable; urgency=medium

  [ Steffen Moeller ]
  * d/u/metadata: yamllint
  * Update metadata with ref to conda

  [ Shayan Doust ]
  * Fix debian/rules not trapping for errors (Closes: #944572)
  * Specify architectures that can build this package
  * More verbose output and slight change to simkamin.install

  [ Andreas Tille ]
  * Standards-Version: 4.4.1
  * Remove trailing whitespace in debian/rules
  * Set upstream metadata fields: Repository.

 -- Shayan Doust <hello@shayandoust.me>  Mon, 18 Nov 2019 07:05:39 +0100

simka (1.5.1-1) unstable; urgency=medium

  * Initial release (Closes: #940559)

 -- Shayan Doust <hello@shayandoust.me>  Sun, 08 Sep 2019 22:20:14 +0100

=== debian/control ===
Source: simka
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Shayan Doust <hello@shayandoust.me>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 12),
               cmake,
               libgatbcore-dev,
               zlib1g-dev,
               libhdf5-dev,
               libboost-dev,
               python3-all,
               dh-python,
               chrpath
Standards-Version: 4.4.1
Vcs-Browser: https://salsa.debian.org/med-team/simka
Vcs-Git: https://salsa.debian.org/med-team/simka.git
Homepage: https://github.com/GATB/simka

Package: simka
Architecture: amd64 arm64 i386 ppc64el s390x hppa ia64 ppc64 riscv64 sparc64
Depends: ${shlibs:Depends},
         ${misc:Depends},
Description: comparative metagenomics method dedicated to NGS datasets
 Simka is a de novo comparative metagenomics tool. Simka represents each
 dataset as a k-mer spectrum and compute several classical ecological
 distances between them.

Package: simkamin
Architecture: all
Depends: ${python3:Depends},
         ${misc:Depends},
         python3
Description: approximate comparative metagenomics method dedicated to NGS datasets
 Simka is a de novo comparative metagenomics tool. Simka represents each
 dataset as a k-mer spectrum and compute several classical ecological
 distances between them.
 .
 The difference with Simka stands in the fact that SimkaMin outputs
 approximate (but very similar) results by subsampling the kmer space.
 With this strategy, and with default parameters, SimkaMin is an order
 of magnitude faster, uses 10 times less memory and 70 times less disk
 than Simka.

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1
export LC_ALL=C.UTF-8

include /usr/share/dpkg/default.mk

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@ --with python3

override_dh_install-arch:
	dh_install -a
	chrpath --delete debian/simka/usr/bin/*
	rm -rf debian/tmp/usr/example \
		debian/tmp/usr/scripts

override_dh_install-indep:
	dh_install -i
	ls -l debian/simkamin/usr/share && ls -l debian/simkamin/usr/share/simkamin
	rm -rf debian/tmp/usr/example \
		debian/tmp/usr/scripts
	set -e; for file in debian/simkamin/usr/share/simkamin/*.py; do mv "$$file" "$${file%%.py}"; done
	mv debian/simkamin/usr/share/simkamin/simkaMin_utils debian/simkamin/usr/share/simkamin/simkaMin_utils.py

override_dh_fixperms:
	dh_fixperms
	chmod +x debian/*/usr/bin/*

override_dh_installman:
	dh_installman
	rm -rf debian/simka/usr/share/man/man1/simkaMin.1 \
		debian/simka/usr/share/man/man1/simkaMin_update.1

## simka 1.5.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -7,7 +7,7 @@
 ################################################################################
 SET (gatb-tool_VERSION_MAJOR 1)
 SET (gatb-tool_VERSION_MINOR 5)
-SET (gatb-tool_VERSION_PATCH 1)
+SET (gatb-tool_VERSION_PATCH 2)
 
 IF (DEFINED MAJOR)
     SET (gatb-tool_VERSION_MAJOR ${MAJOR})

=== debian/changelog ===
simka (1.5.2-1) unstable; urgency=medium

  [ Andreas Tille ]
  * Team upload.
  * New upstream version
  * Standards-Version: 4.5.0 (routine-update)
  * debhelper-compat 13 (routine-update)

  [ Shayan Doust ]
  * Refresh patches
  * Override dh_missing

 -- Shayan Doust <hello@shayandoust.me>  Tue, 28 Jul 2020 12:26:25 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Uploaders: Shayan Doust <hello@shayandoust.me>
 Section: science
 Priority: optional
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
                cmake,
                libgatbcore-dev,
                zlib1g-dev,
@@ -12,7 +12,7 @@
                python3-all,
                dh-python,
                chrpath
-Standards-Version: 4.4.1
+Standards-Version: 4.5.0
 Vcs-Browser: https://salsa.debian.org/med-team/simka
 Vcs-Git: https://salsa.debian.org/med-team/simka.git
 Homepage: https://github.com/GATB/simka

=== debian/rules ===
--- 
+++ 
@@ -32,3 +32,6 @@
 	dh_installman
 	rm -rf debian/simka/usr/share/man/man1/simkaMin.1 \
 		debian/simka/usr/share/man/man1/simkaMin_update.1
+
+override_dh_missing:
+

## simka 1.5.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -7,7 +7,7 @@
 ################################################################################
 SET (gatb-tool_VERSION_MAJOR 1)
 SET (gatb-tool_VERSION_MINOR 5)
-SET (gatb-tool_VERSION_PATCH 2)
+SET (gatb-tool_VERSION_PATCH 3)
 
 IF (DEFINED MAJOR)
     SET (gatb-tool_VERSION_MAJOR ${MAJOR})
@@ -92,6 +92,13 @@
 target_link_libraries (simkaMinCore  ${gatb-core-libraries})
 
 ################################################################################
+#  DOCUMENTATION GENERATION 
+################################################################################
+IF (EXISTS "${PROJECT_SOURCE_DIR}/doc")
+    ADD_SUBDIRECTORY(doc EXCLUDE_FROM_ALL)
+ENDIF()
+
+################################################################################
 #  PACKAGING
 ################################################################################

=== doc/CMakeLists.txt ===

find_package (Doxygen)

if (DOXYGEN_FOUND)

    CONFIGURE_FILE (${CMAKE_CURRENT_SOURCE_DIR}/doxygen/gatb-simka.doxyfile  ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile  @ONLY)
    
    ADD_CUSTOM_TARGET (doc-gatb-simka 
      ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
    )
  
endif (DOXYGEN_FOUND)

=== debian/changelog ===
simka (1.5.3-9) unstable; urgency=medium

  * Team upload.
  * Fix build with CMake 4
    Closes: #1113504
  * d/watch: version=5
  * Standards-Version: 4.7.2 (routine-update)
  * debputy lint --auto-fix (routine-update)
  * debian/not-installed: Mention files that are blamed by dh_missing

 -- Andreas Tille <tille@debian.org>  Mon, 20 Oct 2025 15:41:14 +0200

simka (1.5.3-8) unstable; urgency=medium

  * Team upload.
  * Add build support for loongarch64
    Closes: #1059213
  * Build-Depends: s/dh-python/dh-sequence-python3/ (routine-update)

 -- Andreas Tille <tille@debian.org>  Wed, 10 Jan 2024 20:22:10 +0100

simka (1.5.3-7) unstable; urgency=medium

  * Team upload.
  * d/control: Only build on architectures supported by gatb-core.
    (Closes: #1031533)
  * d/control: Bump Standards-Version to 4.6.2; no changes needed.

 -- Sergio Durigan Junior <sergiodj@debian.org>  Fri, 17 Feb 2023 18:01:22 -0500

simka (1.5.3-6) unstable; urgency=medium

  * Team upload.
  * Fix watch file
  * Standards-Version: 4.6.1 (routine-update)

 -- Andreas Tille <tille@debian.org>  Mon, 14 Nov 2022 21:35:04 +0100

simka (1.5.3-5) unstable; urgency=medium

  [ Steffen Moeller ]
  * Team upload.
  * Fix watchfile to detect new versions on github (routine-update)

  [ Andreas Tille ]
  * Standards-Version: 4.6.0 (routine-update)

 -- Andreas Tille <tille@debian.org>  Fri, 10 Sep 2021 09:30:45 +0200

simka (1.5.3-4) unstable; urgency=medium

  * Team upload.
  * debian/tests/run-unit-test: remove misleading argument from Python script.
  * Add high_cores_count.patch to fix deadlock with Python test script.
    (Closes: #986256)

 -- Étienne Mollier <etienne.mollier@mailoo.org>  Wed, 07 Apr 2021 23:12:25 +0200

simka (1.5.3-3) unstable; urgency=medium

  * Team upload.
  * d/tests/run-unit-test: cap nb-cores to 8 cpus when running tests, to avoid
    the test suite to hang on high cores count machines.  (Closes: #986256)

 -- Étienne Mollier <etienne.mollier@mailoo.org>  Mon, 05 Apr 2021 20:02:58 +0200

simka (1.5.3-2) unstable; urgency=high

  * Make autopkgtest have the same arch list as d/control (Closes: #982212)

 -- Shayan Doust <hello@shayandoust.me>  Sun, 07 Feb 2021 20:06:22 +0000

simka (1.5.3-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Standards-Version: 4.5.1 (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Trim trailing whitespace.
  * Fix autopkgtest and mark non-working simkaMin/test_simkaMin.py as
    FIXME

 -- Andreas Tille <tille@debian.org>  Thu, 28 Jan 2021 12:42:03 +0100

=== debian/control ===
Source: simka
Standards-Version: 4.7.2
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders:
 Shayan Doust <hello@shayandoust.me>,
Section: science
Priority: optional
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 libgatbcore-dev,
 zlib1g-dev,
 libhdf5-dev,
 libboost-dev,
 python3-all,
 dh-sequence-python3,
 chrpath,
Vcs-Browser: https://salsa.debian.org/med-team/simka
Vcs-Git: https://salsa.debian.org/med-team/simka.git
Homepage: https://github.com/GATB/simka
Rules-Requires-Root: no

Package: simka
Architecture: any-amd64 arm64 loong64 mips64el ppc64el ia64 ppc64 riscv64 sparc64 alpha
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: comparative metagenomics method dedicated to NGS datasets
 Simka is a de novo comparative metagenomics tool. Simka represents each
 dataset as a k-mer spectrum and compute several classical ecological
 distances between them.

Package: simkamin
Architecture: all
Depends:
 ${python3:Depends},
 ${misc:Depends},
 python3,
Description: approximate comparative metagenomics method dedicated to NGS datasets
 Simka is a de novo comparative metagenomics tool. Simka represents each
 dataset as a k-mer spectrum and compute several classical ecological
 distances between them.
 .
 The difference with Simka stands in the fact that SimkaMin outputs
 approximate (but very similar) results by subsampling the kmer space.
 With this strategy, and with default parameters, SimkaMin is an order
 of magnitude faster, uses 10 times less memory and 70 times less disk
 than Simka.

=== debian/rules ===
--- 
+++ 
@@ -8,7 +8,10 @@
 export DEB_BUILD_MAINT_OPTIONS=hardening=+all
 
 %:
-	dh $@ --with python3
+	dh $@
+
+override_dh_auto_configure:
+	dh_auto_configure -- -DCMAKE_POLICY_VERSION_MINIMUM=3.5
 
 override_dh_install-arch:
 	dh_install -a
@@ -32,6 +35,3 @@
 	dh_installman
 	rm -rf debian/simka/usr/share/man/man1/simkaMin.1 \
 		debian/simka/usr/share/man/man1/simkaMin_update.1
-
-override_dh_missing:
-

=== debian/tests/control ===
Tests: run-unit-test
Depends: @
Restrictions: allow-stderr
Architecture: amd64 arm64 i386 loong64 ppc64el s390x hppa ia64 ppc64 riscv64 sparc64

=== debian/watch ===
Version: 5

Template: Github
Owner: GATB
Project: simka
